' ADODB.Stream file I/O constants
Const adTypeBinary          = 1
Const adTypeText            = 2
Const adSaveCreateNotExist  = 1
Const adSaveCreateOverWrite = 2

Const BOM1 = &HEF
Const BOM2 = &HBB
Const BOM3 = &HBF

BOM = ChrB(BOM1)+ChrB(BOM2)+ChrB(BOM3)

Set fso = CreateObject("Scripting.FileSystemObject")
    
Sub echo(what)
	on Error resume Next
	WScript.StdOut.WriteLine "" & what
End Sub    

Function MultiByteToBinary(MultiByte)
    Const adLongVarBinary = 205
    Set RS = CreateObject("ADODB.Recordset")
    LMultiByte = LenB(MultiByte)
    RS.Fields.Append "mBinary", adLongVarBinary, LMultiByte
    RS.Open
    RS.AddNew
    RS("mBinary").AppendChunk MultiByte & ChrB(0)
    RS.Update
    MultiByteToBinary = RS("mBinary").GetChunk(LMultiByte)
    RS.Close
    set RS = nothing
End Function

Function ConcatByteArrays(bytes1, bytes2)
    Set oStream = CreateObject("ADODB.Stream")
    oStream.Open
    oStream.Type = adTypeBinary
    oStream.Write bytes1
    oStream.Write bytes2
    oStream.Position = 0
    ConcatByteArrays = oStream.Read(LenB(bytes1) + LenB(bytes2))
    oStream.Close
End Function

Function ReadBinaryFile(FileName)
  Set BinaryStream = CreateObject("ADODB.Stream")
  BinaryStream.Type = adTypeBinary
  BinaryStream.Open
  BinaryStream.LoadFromFile FileName
  ReadBinaryFile = BinaryStream.Read
End Function

Sub SaveBinaryData(FileName, ByteArray)
  Set BinaryStream = CreateObject("ADODB.Stream")
  BinaryStream.Type = adTypeBinary
  BinaryStream.Open
  BinaryStream.Write ByteArray
  BinaryStream.SaveToFile FileName, adSaveCreateOverWrite
End Sub

If WScript.Arguments.Count=0 Then
	echo "call " & WScript.ScriptName & " with parameter UTF8 filename"
	WScript.Quit
End If

FileName = WScript.Arguments.Item(0)
If fso.FileExists(FileName)=0 Then 
	echo "not existing: " & FileName
	WScript.quit
End If

data = ReadBinaryFile(FileName)

If (MidB(data, 1, 1)<>ChrB(BOM1)) Or (MidB(data, 2, 1)<>ChrB(BOM2)) Or (MidB(data, 3, 1)<>ChrB(BOM3)) Then
	' there is no BOM
	' done
	WScript.Quit
End If

data = MultiByteToBinary(MidB(data, 4))

' Write everything but the first 3 Bytes
SaveBinaryData FileName, data
	
